<?php
 namespace MongoDB\Tests\Operation;
 use MongoDB\Exception\InvalidArgumentException;
 use MongoDB\Operation\Count;
 class CountTest extends TestCase {
 public function testConstructorFilterArgumentTypeCheck($filter) {
 $this->expectException(InvalidArgumentException::class);
 new Count($this->getDatabaseName(), $this->getCollectionName(), $filter);
 }
 public function testConstructorOptionTypeChecks(array $options) {
 $this->expectException(InvalidArgumentException::class);
 new Count($this->getDatabaseName(), $this->getCollectionName(), [], $options);
 }
 public function provideInvalidConstructorOptions() {
 $options = [];
 foreach ($this->getInvalidDocumentValues() as $value) {
 $options[][] = ['collation' => $value];
 }
 foreach ($this->getInvalidHintValues() as $value) {
 $options[][] = ['hint' => $value];
 }
 foreach ($this->getInvalidIntegerValues() as $value) {
 $options[][] = ['limit' => $value];
 }
 foreach ($this->getInvalidIntegerValues() as $value) {
 $options[][] = ['maxTimeMS' => $value];
 }
 foreach ($this->getInvalidReadConcernValues() as $value) {
 $options[][] = ['readConcern' => $value];
 }
 foreach ($this->getInvalidReadPreferenceValues() as $value) {
 $options[][] = ['readPreference' => $value];
 }
 foreach ($this->getInvalidSessionValues() as $value) {
 $options[][] = ['session' => $value];
 }
 foreach ($this->getInvalidIntegerValues() as $value) {
 $options[][] = ['skip' => $value];
 }
 return $options;
 }
 private function getInvalidHintValues() {
 return [123, 3.14, true];
 }
 }
 